package cz.muni.fi.pb162.graphics;

import java.util.List;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

public class Polygon extends AbstractGrObject
{
    private List<Point> points;
 
    public Polygon(Color color) {
        super(color);
        this.points = new ArrayList<Point>();
    }
    
    public void addPoint(Point point) {
        if (point == null) throw new IllegalArgumentException("point");
        points.add(point);
    }
    
    public double getPerimeter() {
        double ret = 0;
        
        for (int i = 0; i < points.size(); i++) {
            Point p1 = points.get(i);
            Point p2 = points.get((i+1)%points.size());
            ret += getLineLength(p1, p2);
        }
              
        return ret;
    }
    
    /**
     * @param p1 first point of the line segment
     * @param p2 second point of the line segment
     * @return length of the line segment, -1.0 on error
     */
    protected static double getLineLength(Point p1, Point p2) { 
        //if (p1 == null || p2 == null) {
        //    return -1.0;
        //}
        
        int dx = p1.getX() - p2.getX();
        int dy = p1.getY() - p2.getY();
        return Math.sqrt(dx * dx + dy * dy);
    }
    
    public Collection<Point> getPoints() {
        return Collections.unmodifiableList(points);
    }
}

















